Description: make generation of clang bindings more portable
 Allow user to override
 - CLANG_VERSION
 - CLANG_SRC_DIR (by using abspath instead of pwd in CLAN_INCLUDE_DIR)
 - GCC_DUMPMACHINE
 .
 Update for gcc-9, which uses aspects instead of pragmas.
Author: Nicolas Boulenguez <nicolas@debian.org>

--- a/libclang/Makefile
+++ b/libclang/Makefile
@@ -1,37 +1,50 @@
 TMP_GEN_DIR=gen
 CLANG_RELEASE=3.7.1
 CLANG_SRC_DIR=cfe-$(CLANG_RELEASE).src
-CLANG_INCLUDE_DIR=$(shell pwd)/$(CLANG_SRC_DIR)/include
+CLANG_INCLUDE_DIR=$(abspath $(CLANG_SRC_DIR)/include)
 CLANG_INCLUDE_DIR_C=$(CLANG_INCLUDE_DIR)/clang-c
 DL=wget
 CLANG_SRC_FNAME=$(CLANG_SRC_DIR).tar.xz
 CLANG_SRC_LINK=http://llvm.org/releases/$(CLANG_RELEASE)/$(CLANG_SRC_FNAME)
 
+GCC_DUMPMACHINE := `gcc -dumpmachine`
+
+CXXFLAGS := \
+  -I/usr/include/$(GCC_DUMPMACHINE) \
+  -I$(CLANG_INCLUDE_DIR) \
+  -DNDEBUG \
+  -D_GNU_SOURCE \
+  -D__STDC_CONSTANT_MACROS \
+  -D__STDC_FORMAT_MACROS \
+  -D__STDC_LIMIT_MACROS \
+  -U__cplusplus \
+  -D_Bool=bool
+
 ifeq ($(wildcard binding/clang.ads),)
-all: clean_imports
+all: $(TMP_GEN_DIR)
 else
 all:
 endif
 
-init: init_gen init_clang_src
-
-init_gen:
-	mkdir -p $(TMP_GEN_DIR)
+$(CLANG_SRC_DIR):
+	$(DL) $(CLANG_SRC_LINK) --output-document=- | tar xv
 
-init_clang_src:
-	if [ ! -d $(CLANG_SRC_DIR) ]; then $(DL) $(CLANG_SRC_LINK) && tar xvf $(CLANG_SRC_FNAME) && rm $(CLANG_SRC_FNAME); fi
+$(TMP_GEN_DIR).orig: $(CLANG_SRC_DIR)
+	mkdir $@
+	cd $@ && g++ $(CXXFLAGS) -c -fdump-ada-spec $(CLANG_INCLUDE_DIR_C)/*.h
+
+$(TMP_GEN_DIR): $(TMP_GEN_DIR).orig
+	mkdir $@
+	cp $</stddef_h.ads $@
+	for f in $</clang_c*_h.ads; do \
+	  python3 script.py < $$f > $@/`basename $$f`; \
+	done
 
-generate_fdump_bindings: init
-	cd $(TMP_GEN_DIR) && g++ -I/usr/include/x86_64-linux-gnu -I$(CLANG_INCLUDE_DIR) -DNDEBUG -D_GNU_SOURCE -D__STDC_CONSTANT_MACROS -D__STDC_FORMAT_MACROS -D__STDC_LIMIT_MACROS -U__cplusplus -c -D_Bool=bool -fdump-ada-spec $(CLANG_INCLUDE_DIR_C)/*.h
-
-clean_imports: generate_fdump_bindings
-	sed -e 's/pragma Import (CPP, \(.*\), ".*");/pragma Import (C, \1, "\1");/g' -i $(TMP_GEN_DIR)/clang_c_*_h.ads
-	sed -e 's/\(with Interfaces.C; use Interfaces.C;\)/pragma Warnings (Off); \1 pragma Warnings (On);/g' -i $(TMP_GEN_DIR)/clang_c_*_h.ads
-	sed -e 's/\(^.*[t|T]ime.*$\\)/--  \\1/g' -i $(TMP_GEN_DIR)/clang_c_index_h.ads
-	rm $(TMP_GEN_DIR)/*time* $(TMP_GEN_DIR)/*types*
+diff: $(TMP_GEN_DIR).orig $(TMP_GEN_DIR)
+	diff -urN $^
 
 clean:
-	rm $(TMP_GEN_DIR) -rf
+	rm $(TMP_GEN_DIR) $(TMP_GEN_DIR).orig -rf
 
 distclean: clean
 	rm $(CLANG_SRC_DIR) -rf
--- /dev/null
+++ b/libclang/script.py
@@ -0,0 +1,25 @@
+#!/bin/python3
+
+import re
+
+while True:
+    try:
+        l = input ()
+    except EOFError:
+        break
+
+    match = re.match (r' *(?:function|procedure) ([A-Za-z0-9_]+)', l)
+    if match:
+        while not l.endswith ('";'):
+            l += '\n' + input ()
+        l = re.sub (r'Convention => CPP',
+                    r'Convention => C',
+                    l)
+        l = re.sub (r'External_Name => "[^"]+',
+                    r'External_Name => "' + match.group (1),
+                    l)
+
+    if re.search (r'time_t_h', l):
+        l = re.sub (r'^', r'--  ', l, flags=re.MULTILINE)
+
+    print (l)
